#include <string>


#ifndef H__MULTI__H
#define H__MULTI__H

using namespace std;


void DWBox(DWORD dw,bool hex=false,char *title="");
void DWBox(DWORD dw,bool hex,char *title)
{
    char temp[50];
    itoa(dw,temp,(hex?16:10));
    MessageBox(0,temp,title,0);
}


char* cat(char* c1,char* c2)
{
     char* c=new char[strlen(c1)+strlen(c1)+1];
     strcpy(c,c1);
     strcat(c,c2);
     return c;
}

char* cat(const char* c1,char* c2)
{
     char* c=new char[strlen(c1)+strlen(c1)+1];
     strcpy(c,c1);
     strcat(c,c2);
     return c;
}

char* cat(char* c1,const char* c2)
{
     char* c=new char[strlen(c1)+strlen(c1)+1];
     strcpy(c,c1);
     strcat(c,c2);
     return c;
}

char* cat(const char* c1,const char* c2)
{
     char* c=new char[strlen(c1)+strlen(c1)+1];
     strcpy(c,c1);
     strcat(c,c2);
     return c;
}




char* Str2Hex(char *str)
{
    char *ges="";
    for(int x=0; x<strlen(str); x++)
    {
        BYTE ch=(BYTE)str[x];
        char buff[2];
        itoa(ch,buff,16);
        ges=cat(ges,buff);
    }
    return ges;
}

char* Str2Hex(const char *str)
{
    char *ges="";
    for(int x=0; x<strlen(str); x++)
    {
        BYTE ch=(BYTE)str[x];
        char buff[2];
        itoa(ch,buff,16);
        ges=cat(ges,buff);
    }
    return ges;
}

BYTE _HCTI(char cha)
{
    if (cha>='A' && cha<='Z') cha-='A'+'a'; //tolower
    switch (cha)
    {
        case 'f':
            return 15;
        case 'e':
            return 14;
        case 'd':
            return 13;
        case 'c':
            return 12;
        case 'b':
            return 11;
        case 'a':
            return 10;
        default:
            char bu[2];
            bu[1]='\0';
            bu[0]=cha;
            return atoi(bu);
    }
    return 0;
}

char* Hex2Str(char *str)
{
    char *ges="";
    for(int x=0; x<strlen(str); x+=2)
    {
        BYTE ch;
        ch=_HCTI(str[x]);
        ch=ch<<4;
        ch+=_HCTI(str[x+1]);
        char buff[2];
        buff[1]='\0';
        buff[0]=(char)ch;
        ges=cat(ges,buff);
    }
    return ges;
}

char* Hex2Str(const char *str)
{
    char *ges="";
    for(int x=0; x<strlen(str); x+=2)
    {
        BYTE ch;
        ch=_HCTI(str[x]);
        ch=ch<<4;
        ch+=_HCTI(str[x+1]);
        char buff[2];
        buff[1]='\0';
        buff[0]=(char)ch;
        ges=cat(ges,buff);
    }
    return ges;
}

#endif
