#include <windows.h>
#include <fstream>

using namespace std;


#ifndef __H__File_H__
#define __H__File_H__


void _FilePutTogether(char *f1,char *f2,char *outf);
void _FilePutTogether(char *f1,char *f2,char *outf)
{
    long readlen, readlen2;
    char data[10000];

    DeleteFile(outf);
    ofstream out(outf,ios_base::binary|ios_base::out);
    ifstream in(f1,ios_base::binary|ios_base::in);
    ifstream in2(f2,ios_base::binary|ios_base::in);
    
    // get readlen of files
    in.seekg (0, ios::end);
    readlen = in.tellg();
    in.seekg (0, ios::beg);

    in2.seekg (0, ios::end);
    readlen2 = in2.tellg();
    in2.seekg (0, ios::beg);

    
    char l[51];
    itoa(readlen,l,10);
    out << l << "\n";
    
    while (readlen > 10000)
    {
        in.read(data,10000);
        out.write(data,10000);
        readlen -= 10000;
    }
    in.read(data,readlen);
    out.write(data,readlen);
    
    while (readlen2 > 10000)
    {
        in2.read(data,10000);
        out.write(data,10000);
        readlen2 -= 10000;
    }
    in2.read(data,readlen2);
    out.write(data,readlen2);

    
    out.close();
    in.close();
    in2.close();
}


void _FileSplit(char *f,char *f1,char *f2);
void _FileSplit(char *f,char *f1,char *f2)
{
    DeleteFile(f1);
    DeleteFile(f2);
    ifstream in(f,ios_base::binary|ios_base::in);
    ofstream o1(f1,ios_base::binary|ios_base::out);
    ofstream o2(f2,ios_base::binary|ios_base::out);
    
    char d[10000];
    long readlen;
    
    char l[51];
    in.getline(l,50);
    readlen=atoi(l);
    
    while (readlen>10000)
    {
        in.read(d,10000);
        o1.write(d,10000);
        readlen-=10000;
    }
    in.read(d,readlen);
    o1.write(d,readlen);
    
	
	int t=in.tellg();
    in.seekg (0, ios::end);
    readlen = (int)in.tellg()-t;
    in.seekg (t);

    while (readlen>10000)
    {
        in.read(d,10000);
        o2.write(d,10000);
        readlen-=10000;
    }
    in.read(d,readlen);
    o2.write(d,readlen);

    in.close();
    o1.close();
    o2.close();
}

#endif


/*
int main(int argc, char *argv[])
{
    _FilePutTogether("txt.txt","bg.png","zout.isms");
    _FileSplit("zout.isms","txt.txt","bg.png");
    DeleteFile("zout.isms");
    return 0;
}
*/
